#include <bits/stdc++.h>

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int,int> ii;
typedef pair<double,double> dd;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<vector<int>> vvi;
typedef vector<ii> vii;

int kmp_step(char x, string &needle, int s, int* f){
    while(s> 0 && needle[s] != x) s = f[s-1];
    if (needle[s] == x) s++;
    return s;
}

void kmp_construct(int *f, string &needle){
    f[0] =0;
    for(int i =1;i<needle.length();++i){
        f[i] = kmp_step(needle[i],needle,f[i-1],f);
    }
}

int kmp_search(string &needle, string &haystack){
    int f[needle.length()];
    kmp_construct(f,needle);

    // bool found = false;
    int s = 0;
    for(int i=0;i<haystack.length();++i){
        s = kmp_step(haystack[i],needle,s,f);
        // if(s==needle.length()){
            // found =true;
            // cout << (i-s+1) << endl;
        // }
    }
    return s;
}

int main(){
    ios::sync_with_stdio(false);
    int N; cin >> N;
    string s; cin >> s;
    string sR(s);
    for(int i = 0; i < N; ++i) sR[i] = s[N-1-i];
    cout << N-kmp_search(sR, s) << endl;
}